from collections import deque, defaultdict


def find_guarded_warehouses(n, m, k, roads, guards):
    # Создаем граф в виде списка смежности
    graph = defaultdict(list)

    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    # Множество для хранения охраняемых складов
    guarded_warehouses = set()

    # Проходим по каждому охраннику
    for p, h in guards:
        # BFS для нахождения охраняемых складов
        queue = deque([(p, 0)])  # (номер склада, расстояние)
        visited = set()
        visited.add(p)

        while queue:
            current_warehouse, distance = queue.popleft()
            # Добавляем текущий склад в охраняемые
            guarded_warehouses.add(current_warehouse)

            # Если расстояние превышает выносливость охранника, прекращаем
            if distance < h:
                for neighbor in graph[current_warehouse]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, distance + 1))

    # Преобразуем множество в отсортированный список
    guarded_warehouses = sorted(guarded_warehouses)

    # Выводим результат
    print(len(guarded_warehouses))
    if guarded_warehouses:
        print(" ".join(map(str, guarded_warehouses)))
    else:
        print()


# Чтение входных данных
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m-1)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

# Вызов функции
find_guarded_warehouses(n, m, k, roads, guards)