import math
from itertools import permutations

def distance(x1, y1, x2, y2):
    """Вычисление евклидова расстояния между двумя точками (x1, y1) и (x2, y2)."""
    return math.sqrt((x2 - x1)**2 + (y2 - y1)**2)

def find_min_route(points):
    """Нахождение минимального маршрута с помощью полного перебора всех перестановок."""
    min_distance = float('inf')
    for perm in permutations(points):
        total_distance = 0
        for i in range(len(perm) - 1):
            total_distance += distance(perm[i][0], perm[i][1], perm[i + 1][0], perm[i + 1][1])
        min_distance = min(min_distance, total_distance)
    return min_distance

# Чтение данных с ввода
n = int(input())  # Читаем количество точек
points = []

# Чтение координат каждой точки
for _ in range(n):
    x, y = map(int, input().split())
    points.append((x, y))

# Найдем минимальный маршрут
min_route = find_min_route(points)

# Выводим результат с точностью до 12 знаков после запятой
print(f"{min_route:.12f}")